#include "defextern.h"


#ifndef STRICT
    #define STRICT
#endif

#include <stdio.h>
#include <stdlib.h>

#include <windows.h>
#include <winsock2.h>
#include <windowsx.h>
#include <commctrl.h>

#include "resource.h"
#include "mail.h"
#include "main.h"
#include "initial.h"
#include "list.h"
#include "multimail.h"
#include "statusbar.h"

int sz[]={60,50,80,50,40,40,30,30};//list box 
int colorR,colorG,colorB,cR,cG,cB;
char boxname[7][10]={"O","ݔ","M","ۑ","","M",""};
long itemcount=0;

void setboxname(int n)
{
	if(boxnum!=NPOP_BOX)
	{
		wsprintf(boxtitle,boxtitleform,boxname[boxnum],mailcountnow,mailcount);
		//SendMessage(hStatus,SB_SETTEXT, (WPARAM)1 | 0, (LPARAM)(boxname[n]) );
	}
	else
	{
		if(dbxmail) wsprintf(szBuffer, "OE:%s", npop.title);//boxname[boxnum], 
		else wsprintf(szBuffer, "%s:%s", boxname[boxnum], npop.title);
		wsprintf(boxtitle, boxtitleform, szBuffer, npop.getskip()+1, npop.getmax());
		//SendMessage(hStatus,SB_SETTEXT, (WPARAM)1 | 0, (LPARAM)(getmultiname()) );
	}
}

char *getboxname(int n)
{
	return boxname[n];
}


void initlistcolor(HWND hList)
{
	colorR=GetRValue(ListView_GetTextColor(hList));
	colorG=GetGValue(ListView_GetTextColor(hList));
	colorB=GetBValue(ListView_GetTextColor(hList));
	cR =250;
	cG =0;
	cB =0;
}

// listbox Ɂ@wb_\ BYTE
void insertlist(HWND hList,int iNo,mailheader *mh)
{
	if(boxnum==SENT_BOX || boxnum==DUST_BOX || boxnum==SAVE_BOX ) ListView_SetTextColor(hList,RGB(cR,cG,cB));
	else ListView_SetTextColor(hList,RGB(colorR,colorG,colorB));

	if(!HideSubject) InsertItem(hList, iNo - 1, L_POS_SUBJECT, mh->subject);
	else InsertItem(hList, iNo - 1, L_POS_SUBJECT, "*");
	if(boxnum!=SENT_BOX && boxnum!=SEND_BOX )
	{
		InsertItem(hList, iNo - 1, L_POS_TARGET, mh->from);
		InsertItem(hList, iNo - 1, L_POS_DATE, (char*)&(mh->dated[2]));
	}
	else
	{
		InsertItem(hList, iNo - 1, L_POS_TARGET, mh->to);
		InsertItem(hList, iNo - 1, L_POS_DATE, (char*)&(mh->date[3]));
	}
	InsertItem(hList, iNo - 1, L_POS_SIZE, mh->size);
	InsertItem(hList, iNo - 1, L_POS_FILE, mh->file);
	InsertItem(hList, iNo - 1, L_POS_SESSION, mh->server);
	InsertItem(hList, iNo - 1, L_POS_MARK, mh->mark);
	if(mh->mark[0]==0) InsertItem(hList, iNo - 1, L_POS_MARK, mh->rcvmark);
	InsertItem(hList, iNo - 1, L_POS_ID, mh->id);
}

int getposfromuid(HWND hList, char *uid)
{
	int i;
	char buffer[MAX_PATH];
	for(i=0;i<mailcount;i++)
	{
		ListView_GetItemText(hList, i, L_POS_ID, buffer, MAX_PATH);
		if(strcmp(uid,buffer)==0) return i+1;
	}
	return -1;
}

void InsertItemDel(HWND hList, char *uid, char *mark)
{
	int num= getposfromuid( hList, uid);
	if(num>0)InsertItem( hList, num-1, L_POS_MARK, mark);
}

void MyListView_DeleteAllItems(HWND hlist)
{
	ListView_DeleteAllItems(hlist);
	itemcount=0;
}

void InsertItem(HWND hList, int iItemNo, int iSubNo, char *lpszText)
{
    LVITEM item;

    memset(&item, 0, sizeof(LVITEM));

    item.pszText = lpszText;
    item.iItem = iItemNo;
	item.lParam = itemcount;
    item.iSubItem = iSubNo;

    if (iSubNo == 0)
	{
        item.mask = LVIF_TEXT | LVIF_PARAM;//\[gɂLVIF_PARAM Kv
        ListView_InsertItem(hList, &item);
		itemcount++;
	}
    else
	{
		item.mask = LVIF_TEXT ;
        ListView_SetItem(hList, &item);
	}
    return;
}


void savelistboxsize(HWND &hList)
{
	if(IsWindow(hList)==FALSE) return;
    LVCOLUMN lvcol;
	lvcol.mask = LVCF_FMT | LVCF_WIDTH  ;//| LVCF_TEXT | LVCF_SUBITEM
	for (int i=0;i<NO_OF_SUBITEM-1;i++)
	{
		if(ListView_GetColumn(hList, i, &lvcol)) sz[i]=lvcol.cx;
	}
}

//ListView_GetColumn(hwnd, iCol, pcol)


void SaveColumnSize()
{
	for (int i=0;i<NO_OF_SUBITEM-1;i++)
	{
		saveinitcolumnsize(i,sz[i]);
	}
}

//RGB

void initsizeget()
{
	int i,size;

	for(i=0;i<NO_OF_SUBITEM-1;i++)
	{
		size = initcolumnsize(i);
		if(size>0) sz[i]=size;
	}
}

void InsertColumn(HWND hList)
{
    LVCOLUMN lvcol;
	initsizeget();


    lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM ;
    lvcol.fmt = LVCFMT_LEFT;
    lvcol.cx = sz[L_POS_SUBJECT];
    lvcol.pszText = "";
    lvcol.iSubItem = L_POS_SUBJECT;
    ListView_InsertColumn(hList, L_POS_SUBJECT, &lvcol);

    lvcol.cx = sz[L_POS_TARGET];
    lvcol.pszText = "";
    lvcol.iSubItem = L_POS_TARGET;
    ListView_InsertColumn(hList, L_POS_TARGET, &lvcol);

    lvcol.cx = sz[L_POS_DATE];
    lvcol.pszText = "t";
    lvcol.iSubItem = L_POS_DATE;
    ListView_InsertColumn(hList, L_POS_DATE, &lvcol);

    lvcol.fmt = LVCFMT_RIGHT;
    lvcol.cx = sz[L_POS_SIZE];
    lvcol.pszText = "TCY";
    lvcol.iSubItem = L_POS_SIZE;
    ListView_InsertColumn(hList, L_POS_SIZE, &lvcol);

    lvcol.fmt = LVCFMT_LEFT;
    lvcol.cx = sz[L_POS_ID];
    lvcol.pszText = "ID";
    lvcol.iSubItem = L_POS_ID;
    ListView_InsertColumn(hList, L_POS_ID, &lvcol);

    lvcol.cx = sz[L_POS_FILE];
    lvcol.pszText = "O";
    lvcol.iSubItem = L_POS_FILE;
    ListView_InsertColumn(hList, L_POS_FILE, &lvcol);

    lvcol.cx = sz[L_POS_SESSION];
    lvcol.pszText = "ZbV";
    lvcol.iSubItem = L_POS_SESSION;
    ListView_InsertColumn(hList, L_POS_SESSION, &lvcol);

    lvcol.cx = sz[L_POS_MARK];
    lvcol.pszText = "";
    lvcol.iSubItem = L_POS_MARK;
    ListView_InsertColumn(hList, L_POS_MARK, &lvcol);


    return;
}


