
#include "defextern.h"


#ifndef STRICT
    #define STRICT
#endif
/*
#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include <windowsx.h>
#include <commctrl.h>
*/
#include <windows.h>

#include "main.h"
#include "mail.h"
#include "initial.h"
#include "statusbar.h"
#include "jis.h"
#include "buffer.h"
#include "digit.h"
#include "attachfile.h"

char m[][5]={ "Jan","1","Feb","2","Mar","3","Apr","4","May","5","Jun","6","Jul","7",
			"Aug","8","Sep","9","Oct","10","Nov","11","Dec","12"};
char mbuf[MAX_EDIT];


void mailheader::init()
{
	bAttach=FALSE;
	memset(from,0,MAX_SUBJECT);
	memset(to,0,MAX_SUBJECTS);
	memset(cc,0,MAX_SUBJECTS);
	memset(bcc,0,MAX_SUBJECTS);
	memset(replyto,0,MAX_SUBJECT);
	memset(subject,0,MAX_SUBJECT);
	memset(linesw,0,MAX_SUBJECT);
	boundary[0]=0;
	//memset(id,0,MAX_SUBJECT);
}


void mailheader::reset()
{
	bAttach=FALSE;
	mailer[0]=0;
	mark[0]=0;
	subject[0]=0;
	from[0]=0;
	to[0]=0;
	cc[0]=0;
	bcc[0]=0;
	size[0]=0;
	linesw[0]=0;
	memset(date,0,MAX_SUBJECT);
	memset(dated,0,MAX_SUBJECT);
	id[0]=0;
	file[0]=0;
	server[0]=0;
	references[0]=0;
	messageid[0]=0;
	inreplyto[0]=0;
	boundary[0]=0;
}

void mailheader::SetTo(char *ch)
{
	wsprintf(to,"%s",ch);
}

// outlook mail s

void mailheader::calclines()
{
	sscanf(linesw,"%d",&lines);
	lines=min(max(lines,0),100);
}


BOOL ismonth(char *dat)
{
	BOOL f=FALSE;
	for (int i=0;i<=22;i+=2) 
	{
		if(strncmp(dat,m[i],3)==0)
		{
			f=TRUE;
			break;
		}
	}
	return f;
}

BOOL isyear(char *dat)
{
	BOOL f=TRUE;
	for (int i=0;i<strlen(dat);i++) 
	{
		if(isdigit(dat[i])==0)
		{
			f=FALSE;
			break;
		}
	}
	return f;
}


void mailheader::calcmonth()
{
	BOOL f=FALSE;
	for (int i=0;i<=22;i+=2) 
	{
		if(strncmp(month,m[i],3)==0)
		{
			f=TRUE;
			break;
		}
	}
	if(f) strcpy(month,m[i+1]);
}



void mailheader::timereset()
{
	memset(dated,0,sizeof(dated));
	memset(sun,0,sizeof(sun));
	memset(day,0,sizeof(day));
	memset(month,0,sizeof(month));
	memset(year,0,sizeof(year));
	memset(time,0,sizeof(time));
	memset(zone,0,sizeof(zone));
}


// N@בւA蔲

void mailheader::calcdate()
{
	char buffer[100];
	char bu[6][60];
	char *p;
	timereset();

	p=date;
	if(*p==0) return;
	while(*p==' ') p++;
	int i=0;
	strcpy(year,"    ");
	if(strlen(date)>60) date[60]=0;//蔲

	if(strchr(date,'/')!=NULL)
	{
		strncpy(year,p,4);
		strncpy(month,p+5,2);
		strncpy(day,p+8,2);
		strncpy(time,p+11,5);
	}
	else
	{
		for(i=0;i<6;i++) bu[i][0]=0;
		sscanf(date,"%s %s %s %s %s %s",bu[0],bu[1],bu[2],bu[3],bu[4],bu[5]);
		for(i=0;i<6;i++) if(strlen(bu[i])==4 && isyear(bu[i])) strcpy(year,bu[i]);
		if(isdigit(year[0])==0) for(i=0;i<4;i++) if(strlen(bu[i])==2 && isyear(bu[i])) wsprintf(year,"  %s",bu[i]);
		for(i=0;i<6;i++) if(strlen(bu[i])==3) if(ismonth(bu[i])) strcpy(month,bu[i]);
		calcmonth();
		for(i=0;i<6;i++) if(strlen(bu[i])<3 && strlen(bu[i])>0) {strcpy(day,bu[i]);break;}
		for(i=0;i<6;i++) if(strlen(bu[i])>4 && strlen(bu[i])<10 && strchr(bu[i],':')!=NULL) strcpy(time,bu[i]);
		for(i=0;i<6;i++) if(bu[i][0]=='+' || bu[i][0]=='-') strcpy(zone,bu[i]);
		/*
		if(strchr(date,',')!=NULL)
		{
			sscanf(date,"%s %s %s %s %s %s",sun,day,month,year,time,zone);
		}
		else
		{
			if(isdigit(date[0]))
				sscanf(date,"%s %s %s %s %s",day,month,year,time,zone);
			else
				sscanf(date,"%s %s %s %s %s %s",sun,month,day,time,year,zone);
		}*/
	}
	if(date[0]!=0) 
	{
		wsprintf(dated,"%s/%s/%s ",year,month,day);
		wsprintf(buffer,"%s %s",time,zone);
		if(strlen(dated)<11) strncat(dated,"            ",11-strlen(dated));
		strcat(dated,buffer);
	}
	
}


void mailheader::setreply()
{
	char tmp[MAX_SUBJECT];
	strcpy(tmp,subject);
	if(strcmp(tmp,NOSUBJECT)==0) tmp[0]=0;
	wsprintf(subject,"%s%s",returnmark,tmp);
	strcpy(cc,"");
	strcpy(bcc,"");
	strcpy(attachfile,"");
	bAttach=FALSE;
	if(strlen(references)>0) 
	{
		AddReferences(messageid);
	}
	else
	{
		strcpy(references,inreplyto);
		AddReferences(messageid);
	}
	if(strlen(messageid)>0)
	{
		strcpy(inreplyto,messageid);
	}
}

void mailheader::setinreplyto(char *str)
{
	char *p;
	strncpy(inreplyto,str,MAX_SUBJECT);
	if(strlen(str)>=MAX_SUBJECT)
	{
		p=strrchr(inreplyto,'\r');
		if(p!=NULL) *p=0;
	}
}

char *jumpword(char *top,int num)
{
	char *ans=top;
	for (int i=0;i<num;i++) 
	{
		if(ans!=NULL)
		{
			while(strchr("\r\n ",*ans)!=NULL)
			{
				ans++;
			}
			if(ans!=NULL) ans=strchr(ans,' ');
		}
	}
	while(strchr("\r\n ",*ans)!=NULL)
	{
		ans++;
	}
	return ans;
}

// 擪߂
// 111 222 333 444 ...  ->  222 333 444 ...

void cutTop(char *str)
{
	strcpy(mbuf,str);
	char *p;
	p=jumpword(mbuf,1);
	strcpy(str,p);
}

// <....> <......> <....> Ƃ

void AddId(char *org,char *add)
{
	char *p;
	if(strlen(org)>0) strcat(org," ");
	if(strlen(org)+strlen(add)+1 >= MAX_SUBJECT-1 ) cutTop(org);
	strncat(org,add,MAX_SUBJECT-strlen(org)-strlen(" "));
	if(strlen(add)>=MAX_SUBJECT-strlen(org)-strlen(" "))
	{
		p=strrchr(org,' ');
		if(p!=NULL) *p=0;
	}
}

void mailheader::AddInreplyto(char *str)
{
	AddId(inreplyto,str);
}

void mailheader::AddReferences(char *str)
{
	AddId(references,str);
}

void mailheader::setmessageid(char *str)
{
	char *p;
	strncpy(messageid,str,MAX_SUBJECT);
}

void mailheader::setreferences(char *str)
{
	char *p;
	strncpy(references,str,MAX_SUBJECT);
	if(strlen(str)>=MAX_SUBJECT)
	{
		p=strrchr(references,'\r');
		if(p!=NULL) *p=0;
	}
}

void mailheader::getHeaderInfo(char* buf)
{
	wsprintf(buf,
		"o: %s\r\nԐM: %s\r\n: %s\r\n: %s\r\nt: %s\r\n[[: %s\r\nRs[: %s\r\n(Rs[): %s\r\n\r\nbZ[WID: %s\r\nQ: %s\r\nԐM: %s\r\nT[oID: %s\r\n"
		,from,replyto,to,subject,dated,mailer,cc,bcc,messageid,references,inreplyto,id);
}

void mailheader::getHeaderInfoLog(char* buf)
{
	wsprintf(buf,
		"o: %s\r\nԐM: %s\r\n: %s\r\n: %s\r\nt: %s\r\n[[: %s\r\n\r\n"
		,from,replyto,to,subject,dated,mailer);
}

BOOL checkmail(char *str)
{
    char *token;

	token=strstr(str, "Subject:");
	if(token==NULL) token=strstr(str, "subject:");
	if(token==NULL) token=strstr(str, "SUBJECT:");
	if(token==NULL) return FALSE;
	return TRUE;
}


// key ɂăf[^o
// : ̂Ƌ󔒈ꕶ
// Subject: ****

void GetSubject(char *szStrRcv, char *szSubject,char *key)
{
    BOOL bCopy = FALSE;
    char *token;
	//char str[MAX_EDIT];


	szSubject[0]=0;
	if(strstr(szStrRcv, key)==NULL) return;//Ȃꍇ

	token=strstr(szStrRcv, "\r\n\r\n");
	if(token==NULL) token=strstr(szStrRcv, "\n\n");
	if(token==NULL) token=strstr(szStrRcv, "\r\r");
	if(token!=NULL) strcpy(token,"\n:");

    token = strtok(szStrRcv, "\r\n");
    while (token != NULL) {
        if (strstr(token, key) == token) {
            strncpy(szSubject, token + strlen(key)+1,MAX_SUBJECT);
            token = strtok(NULL, "\r\n");
            while (token!=NULL && strlen(token)>0 && strstr(token, ":") == NULL ) {
				if(token[0]==' ') token++;
                strcat(szSubject, token);
                token = strtok(NULL, "\r\n");
            }
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}


void qdecode(char *from, char *to)
{
	char *p,*pt;
	p =from;
	pt =to;
	while(*p!=0)
	{
		if(p[0]=='=')
		{
			if(p[1]==0) break;
			*pt = toint(p[1])*16 +toint(p[2]);
			p+=3;
			pt++;
		}
		else
		{
			if(strlen(p)==2)
			{
				if(strcmp(p,"?=")==0)
				{
					break;
				}
			}
			*pt =*p;
			p++;
			pt++;
		}
	}
	*pt =0;
}

void GetString(char *szOrg, char *szResult,int reslen)
{

	szResult[0]=0;
    char *token;
	const int buflen=MAX_EDIT;
    char szBuf[buflen], szBuf2[buflen];
	char res[buflen]="";
    int len, mod;
    BOOL bCopy = TRUE; //?Rs[Ă悢

	if( strlen(szOrg)==0)//sendmailflag ||
	{
		return;
	}

	//setstatus("debug:getstring()");
	//setstatus(szOrg);
	strcpy(szStr0,szOrg);
    token = strtok(szOrg, "=\r\n\t");
	//setstatus("debug:token");
	//setstatus(token);

	BOOL bflag,qflag;
    while (token != NULL) {
		bflag=(strstr(token, "?ISO-2022-JP?B?") == token || strstr(token, "?iso-2022-jp?B?") == token || strstr(token, "?iso-2022-jp?b?") == token);
		qflag=(strstr(token, "?ISO-2022-JP?Q?") == token || strstr(token, "?iso-2022-jp?Q?") == token || strstr(token, "?iso-2022-jp?q?") == token
			|| strstr(token, "?ISO-2202-JP?Q?") == token || strstr(token, "?iso-2202-jp?Q?") == token || strstr(token, "?iso-2202-jp?q?") == token);
        if (!(bflag || qflag)) 
		{
            if (strcmp(token, "?") != 0 && bCopy == TRUE) {
                MyJisToSJis(token, szBuf);
                strcat(res, szBuf);
            }
        }
		if(bflag)
		{
            strcpy(szBuf, token + 15);
            if (szBuf[strlen(szBuf) - 1] == '?')
                szBuf[strlen(szBuf) - 1] = '=';
            len = strlen(szBuf);
            mod = len % 4;
            switch (mod) {
                case 1:
                    strcat(szBuf, "===");
                    bCopy = FALSE;
                    break;
                case 2:
                    strcat(szBuf, "==");
                    bCopy = FALSE;
                    break;
                case 3:
                    strcat(szBuf, "=");
                    bCopy = FALSE;
                    break;
            }
            decode(szBuf, szBuf2);
            MyJisToSJis(szBuf2, szBuf);
            strcat(res, szBuf);
        }
		if(qflag)
		{
			setstatus("Q,ok");
			token = strtok(szStr0, "\r\n\t");
            strcpy(szBuf, token + 16);
            if (szBuf[strlen(szBuf) - 1] == '?')
                szBuf[strlen(szBuf) - 1] = '=';
            qdecode(szBuf, szBuf2);
            MyJisToSJis(szBuf2, szBuf);
            strcat(res, szBuf);
        }
        bCopy = TRUE;
        token = strtok(NULL, "=\r\n\t");
    }
	if(strlen(res)>reslen-2) res[reslen-1]=0;
	strcpy(szResult,res);
    return;
}
void GetToAddress(char *szStri, char *szTo,char *title)
{
    char *token;
    char szBuf[1024];

	if(strstr(szStri, title)==NULL) return;//Ȃꍇ

	szTo[0]=0;
    token = strtok(szStri, "\r\n");
    while (token != NULL) {
        if (strstr(token, title ) == token) {
			token +=strlen(title) ;
			while(token[0]==' ') token++;
            strncpy(szBuf, token,sizeof(szBuf));//Buf
            GetString(szBuf, szTo, MAX_SUBJECTS);
			break;
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}

void GetAccount(char *szStri, char *szAc)
{
    char *token;
    char szBuf[1024];

	if(strstr(token, "Account:")==NULL) return;

    token = strtok(szStri, "\r\n");
    while (token != NULL) {
        if (strstr(token, "Account:") == token) {
			token +=8;
			while(token[0]==' ') token++;
            strncpy(szBuf, token,sizeof(szBuf));//Buf
            GetString(szBuf, szAc, MAX_SUBJECT);
			break;
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}


void GetReplyto(char *szStri, char *szReply)
{
    char *token;
    char szBuf[1024];

    token = strtok(szStri, "\r\n");
    while (token != NULL) {
        if (strstr(token, "Reply-To:") == token) {
            strncpy(szBuf, token + 9,sizeof(szBuf));//Buf
            GetString(szBuf, szReply, MAX_SUBJECT);
			break;
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}


void GetFrom(char *szStri, char *szFrom)
{
    char *token;
    char szBuf[1024];

    token = strtok(szStri, "\r\n");
    while (token != NULL) {
        if (strstr(token, "From:") == token) {
            strncpy(szBuf, token + 5,sizeof(szBuf));//Buf
            GetString(szBuf, szFrom, MAX_SUBJECT);
			break;
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}



void GetDate(char *szStrRcv, char *szDate)
{
    char *token;

	if(strstr(token, "Date:")==NULL) return;

    token = strtok(szStrRcv, "\r\n");
    while (token != NULL) {
        if (strstr(token, "Date:") == token) {
            strcpy(szDate, token + 5);
			break;
        }
        token = strtok(NULL, "\r\n");
    }
    return;
}



void GetAttach(char *szStrRcv, attach *att ,mailheader *mh)
{
    char *token;

	att->reset();
	if(strstr(szStrRcv,"Attach:")==NULL) return;

    token = strtok(szStrRcv, "\r\n");
    while (token != NULL) {
        if (strstr(token, "Attach:") == token) {
            strcpy(szResult, token + 7);
			att->add(szResult);
        }
        token = strtok(NULL, "\r\n");
    }
	if(att->num >0) mh->bAttach=TRUE;
    return;
}

BOOL IsNpopAddressBook(char *file) 
{
	return (strstr(file,NPOP_ADDRESSBOOK)!=NULL );//蔲
}

void getboundary(char *from, char *to)
{
	to[0]=0;
	char *p;
	from=strchr(from,'\"');
	if(from==NULL) return;
	from++;
	p=strchr(from,'\"');
	if(p==NULL) return;
	*p=0;
	strcpy(to,from);
}

// mh Ƀwb_[荞
// myatt ɓYt荞

void mailheaderanalyze(char *origin,mailheader *mh)
{
	char szCopy[MAX_RCV];
	char *p;

	mh->init();
	if(strstr(origin,"multipart")!=NULL) 
	{
		p=strstr(origin,"boundary=");
		if(p!=NULL) p+=9;
		strcpy(szCopy,p);
		getboundary(szCopy,szStr);
		mh->setboundary(szStr);
		mh->bAttach=TRUE;
	}
	szCopy[0]=0;
	mh->subject[0]=0;
	szStr[0]=0;
	mh->from[0]=0;
	if(origin[0]==0) return;

	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"Lines:");
	GetString(szStr, mh->linesw,MAX_SUBJECT);
	mh->calclines();
	strncpy(szCopy, origin,MAX_RCV);

	GetSubject(szCopy, szStr,"Subject:");
	if (szStr[0]==0)
	{
		strcpy(szCopy, origin);
		GetSubject(szCopy, szStr,"subject:");
	}
	GetString(szStr, mh->subject,MAX_SUBJECT);
	if(mh->subject[0]==0) strcpy(mh->subject,NOSUBJECT);
	memset(szCopy, '\0', sizeof(szCopy));

	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"Message-ID:");
	if(szStr[0]==0) 
	{
		strncpy(szCopy, origin,MAX_RCV);
		GetSubject(szCopy, szStr,"Message-Id:");
	}
	mh->setmessageid(szStr);
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"References:");
	mh->setreferences(szStr);
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"In-Reply-To:");
	mh->setinreplyto(szStr);
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"From:");
	if (szStr[0]==0)
	{
		strcpy(szCopy, origin);
		GetSubject(szCopy, szStr,"FROM:");
	}
	GetString(szStr, mh->from,MAX_SUBJECT);
	strncpy(szCopy, origin,MAX_RCV);
	mh->server[0]=0;
	GetAccount(szCopy, mh->server);
	strncpy(szCopy, origin,MAX_RCV);
	GetToAddress(szCopy, mh->to,"To:");
	strncpy(szCopy, origin,MAX_RCV);
	GetToAddress(szCopy, mh->cc,"Cc:");
	strncpy(szCopy, origin,MAX_RCV);
	GetToAddress(szCopy, mh->bcc,"Bcc:");
	strncpy(szCopy, origin,MAX_RCV);
	GetToAddress(szCopy, mh->replyto,"Reply-To:");
	//GetReplyto(szCopy, mh->replyto);

	memset(szCopy, '\0', sizeof(szCopy));
	strncpy(szCopy, origin,MAX_RCV);
	GetDate(szCopy, mh->date);
	mh->calcdate();
	//attach file
	strncpy(szCopy, origin,MAX_RCV);
	GetAttach(szCopy, &myatt,mh);
	//mailer
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"X-Mailer:");
	mh->setmailer(szStr);
	//mail size
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"Content-Length:");//nPOP 
	if(strlen(szStr)>0) mh->setsize(szStr);
	else if(strcmp(mh->size,"0")==0)
	{
		/**/
		strncpy(szCopy, origin,MAX_RCV);
		GetSubject(szCopy, szStr,"Lines:");//OE 
		if(strlen(szStr)>0) 
		{
			strcat(szStr,"\'");
			mh->setsize(szStr);
		}
	}
	if(strcmp(mh->size,"0")==0) mh->setsize("?");
	//X-Account:X-MailBox:
	strncpy(szCopy, origin,MAX_RCV);
	GetSubject(szCopy, szStr,"X-Account:");
	if(strlen(szStr)==0)
	{
		strncpy(szCopy, origin,MAX_RCV);
		GetSubject(szCopy, szStr,"X-MailBox:");
	}
	if(strlen(szStr)==0)
	{
		strncpy(szCopy, origin,MAX_RCV);
		GetSubject(szCopy, szStr,"Account:");
	}
	mh->setserver(szStr);
	if( npopaddressfile )
	{
		if(strlen(mh->from)==0) strcpy(mh->from,mh->to);
	}
}

//񂩂烁[AhXo
//
// 
// from:<aaa@mail.com> (RcY)
// add :aaa@mail.com

void getmailaddress(char *from, char *add)
{
	char *p,*pp,*top,*end;
	char buffer[MAX_PATH];
	strncpy(buffer,from,MAX_PATH);
	p=strchr(buffer,'@');
	if(p==NULL) add[0]=0;
	else
	{
		pp=strchr(p,' ');
		if(pp!=NULL) pp[0]=0;
		pp=strchr(p,'>');
		if(pp!=NULL) pp[0]=0;
		top=buffer;
		pp=strrchr(top,',');
		if(pp!=NULL) top=pp+1;
		pp=strrchr(top,' ');
		if(pp!=NULL) top=pp+1;
		pp=strrchr(top,'<');
		if(pp!=NULL) top=pp+1;
		strcpy(add,top);
	}
}

// from address ̑O𖼑OƂĎoA܂G

void getmailaddressname(char *from,char *address, char *name)
{
	char *p,*pp,*top,*end;
	char buffer[MAX_PATH];
	strncpy(buffer,from,MAX_PATH);
	if(strlen(from)==strlen(address)) strcpy(name,address);
	else
	{
		p=strstr(buffer,address);
		if(p!=NULL) 
		{
			*p=0;
			if(strlen(buffer)>0)
			{
				top=buffer;
				while(strchr(" \t,\"",*top)!=NULL) top++;
				p=strrchr(top,'<');
				if(p!=NULL) *p=0;
				if(top[strlen(top)-1]==' ') top[strlen(top)-1]=0;
				if(top[strlen(top)-1]=='\"') top[strlen(top)-1]=0;
				strcpy(name,top);
			}
			else
			{
				p+=strlen(address);
				while(strchr("> \t,",*p)!=NULL) p++;
				strcpy(name,p);
			}
		}
	}
	strcpy(buffer,name);
	p=buffer;
	while(*p==' ') p++;
	if(*p=='\"') p++;
	int len=strlen(p);
	int num=0;
	pp=&(p[len-1]);
	while(*pp==' ' && len>num) {pp--;num++;}
	if(*pp=='\"' && len>num) {pp--;num++;}
	if(num>0) p[len-num]=0;
	strcpy(name,p);
}